

public class Grafos {
	
	public Vertice[] vertice;
	
	public Grafos(int size) {
		
		vertice = new Vertice[size];
		
		for(int i = 0; i < size; i++) {
			
			vertice[i] = new Vertice();
		}
		
	}
	
	public void dfs(int v)
	{
		this.resetarTudo();
		this.vertice[v].pai = -1;
		this.recursive_dfs(v);
	}
	
	public void recursive_dfs(int v){
		
		
		System.out.println("Vertice " + v);
		
		this.vertice[v].marcado = true;
		int w;
		
		for(NoAdj noAdj = this.vertice[v].adjacentes.raiz; noAdj != null; noAdj = noAdj.prox )
		{
			w = noAdj.adj.indice;
			
			if( this.vertice[w].marcado == false )
			{
				this.vertice[w].pai = v;
				this.recursive_dfs(w);
			}
			else
			{
				if( this.vertice[v].pai != w )
				{
					noAdj.adj.arestaRetorno = true;
					
					System.out.println("Retorno (" + v + "," +w+ ")");
				}
				else
				{
					noAdj.adj.arestaArvore = true;
				}
			}
		}
	}
	
	
	//FAZ O MTODO RESETAR
	
	public void resetarTudo()
	{
		for(int i=0;i<this.vertice.length; i++){
			this.vertice[i].marcado = false;
			this.vertice[i].pai = 0;
		}
	}
	
	public void bfs(int v)
	{
		
		this.resetarTudo();
		
		Lista fila = new Lista();
		
		fila.inserirFim(v);
		this.vertice[v].marcado = true;
		this.vertice[v].pai = -1;
		
		int w;
		
		while(!fila.ListaVazia()) {
			
			v = fila.removerComeco().valor;
			
			System.out.println(v);
			
			for(NoAdj noAdj = this.vertice[v].adjacentes.raiz; noAdj != null; noAdj = noAdj.prox) {
				
				w = noAdj.adj.indice;
				
				if(this.vertice[w].marcado == false) {
					
					fila.inserirFim(w);
					
					this.vertice[w].marcado = true;
					
					this.vertice[w].pai = v;
					
				}else {
					
					if(this.vertice[v].pai != w) {
						
						noAdj.adj.arestaCruzamento = true;
						noAdj.adj.arestaArvore = false;
						System.out.println("Cruzamento (" + v + "," +w+ ")");
						
					}else
					{
						noAdj.adj.arestaArvore = true;
					}
				}
				
			}
			
			
			
		}
		
	}
	
	
	public static void main(String[] args) {
		// TODO Auto-generated method stub

	}

}
